//xsetaseta@gmail.com
//05/07/2016

#include <SPI.h>
#include "nRF24L01.h"
#include "RF24.h"

#define RELE1 2
#define RELE2 3
#define RELE3 4
#define RELE4 5

char cadena[10];

RF24 radio(8,7);

char r1,r2,r3,r4;
char r1z,r2z,r3z,r4z;

// Topology
// Radio pipe addresses for the 2 nodes to communicate.
const uint64_t pipes[2] = { 0xF0F0F0F0E1LL, 0xF0F0F0F0D2LL };

void setup(void)
{
  Serial.begin(9600);
  pinMode(RELE1,INPUT);
  pinMode(RELE2,INPUT);
  pinMode(RELE3,INPUT);
  pinMode(RELE4,INPUT);
  radio.begin();
  radio.setRetries(15,15);
  radio.openWritingPipe(pipes[0]);
  radio.openReadingPipe(1,pipes[1]);
  Serial.println("Transmitiendo datos");
  demo();
}

void loop(void)
{    
  r1=digitalRead(RELE1);
  if(r1z!=r1)
    {
     r1z=r1;
     if(r1== HIGH)
         Orden("R01ON_");
       else
         Orden("R01OFF");
     delay(200);
    }
 
  r2=digitalRead(RELE2);
  if(r2z!=r2)
    {
     r2z=r2;
     if(r2== HIGH)
         Orden("R02ON_");
       else
         Orden("R02OFF");
     delay(200);
    }
  
  r3=digitalRead(RELE3);
  if(r3z!=r3)
    {
     r3z=r3;
     if(r3== HIGH)
         Orden("R03ON_");
       else
         Orden("R03OFF");
     delay(200);
    }
    
  r4=digitalRead(RELE4);
  if(r4z!=r4)
    {
     r4z=r4;
     if(r4== HIGH)
         Orden("R04ON_");
       else
         Orden("R04OFF");
     delay(200);
    } 
    
    delay(100);
 
}

void demo()
{
    Orden("R01ON_");   delay(300);  
    Orden("R01OFF");   delay(300);     
    Orden("R02ON_");   delay(300);   
    Orden("R02OFF");   delay(300);   
    Orden("R03ON_");   delay(300);   
    Orden("R03OFF");   delay(300);    
    Orden("R04ON_");   delay(300);   
    Orden("R04OFF");   delay(300); 
}

void Orden(char *p)
{
    radio.stopListening();
    sprintf(cadena,"%s",p);
    Serial.println(cadena);
    enviarS();   
    radio.startListening();
}

void enviarS()
{
    Serial.print("Enviando  ");
    Serial.print(cadena);   

    if (radio.write( cadena, 6 ))
      { Serial.println(" ok send.");}
    else
      { Serial.println(" failed send.");}  
}
