//xsetaseta@gmail.com
//05/07/2016

#include <SPI.h>
#include "nRF24L01.h"
#include "RF24.h"


#define RELE1 2
#define RELE2 3
#define RELE3 4
#define RELE4 5



int canal[16];
byte ca;

char cadena[10];
int z;
bool done;

//RF24 (cepin, cspin) 
RF24 radio(8,7);

// Topology
// Radio pipe addresses for the 2 nodes to communicate.
const uint64_t pipes[2] = { 0xF0F0F0F0E1LL, 0xF0F0F0F0D2LL };

void setup(void)
{
 Serial.begin(9600);
 
  pinMode(RELE1,OUTPUT);
  pinMode(RELE2,OUTPUT);
  pinMode(RELE3,OUTPUT);
  pinMode(RELE4,OUTPUT);
  
  digitalWrite(RELE1, HIGH);
  digitalWrite(RELE2, HIGH);
  digitalWrite(RELE3, HIGH);
  digitalWrite(RELE4, HIGH);

  radio.begin();
  radio.setRetries(15,15);
  radio.startListening();
  radio.openWritingPipe(pipes[1]);
  radio.openReadingPipe(1,pipes[0]);
  Serial.println("Esperando datos");
}

void loop(void)
{
 
    if ( radio.available() )
    {
  
      //unsigned long got_time;
      done = false;
      while (!done)
        {
        done = radio.read( cadena, 6);
        Serial.print("Dato Recibido ="); Serial.println(cadena);
        
          if(!strcmp(cadena,"R01ON_")){digitalWrite(RELE1, LOW); goto SALTO;}
          if(!strcmp(cadena,"R01OFF")){digitalWrite(RELE1, HIGH); goto SALTO;}
          
          if(!strcmp(cadena,"R02ON_")){digitalWrite(RELE2, LOW); goto SALTO;}
          if(!strcmp(cadena,"R02OFF")){digitalWrite(RELE2, HIGH); goto SALTO;}
          
          if(!strcmp(cadena,"R03ON_")){digitalWrite(RELE3, LOW); goto SALTO;}
          if(!strcmp(cadena,"R03OFF")){digitalWrite(RELE3, HIGH); goto SALTO;}
          
          if(!strcmp(cadena,"R04ON_")){digitalWrite(RELE4, LOW); goto SALTO;}
          if(!strcmp(cadena,"R04OFF")){digitalWrite(RELE4, HIGH); goto SALTO;}
SALTO:
        delay(50); //20
        }

      radio.stopListening();
      delay(100);  //20
      radio.startListening();
    }
    
}
